﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Infragistics.Controls.Grids;

namespace SilverlightApplication14
{
  public class IsLockedCondition : DiscreetRuleBase
  {
    private string _key = "";

    public IsLockedCondition(string key)
    {
      _key = key;
    }

    protected override IConditionalFormattingRuleProxy CreateProxy()
    {
      return new IsLockedConditionConditionProxy(this.StyleToApply, _key);
    }
  }

  public class IsLockedConditionConditionProxy : DiscreetRuleBaseProxy
  {
    private Style _style = null;
    private string _key = "";

    public IsLockedConditionConditionProxy(Style style, string key)
    {
      _style = style;
      _key = key;
    }

    protected override Style EvaluateCondition(object sourceDataObject, object sourceDataValue)
    {
      Value value = null;

      if (_key == "Value1")
      {
        value = ((RowLevelBase)sourceDataObject).Value1;
      }
      else if (_key == "Value2")
      {
        value = ((RowLevelBase)sourceDataObject).Value2;
      }
      if (value.IsLocked)
      {
        return _style;
      }
      return null;
    }
  }
}
